"""XML Client Prodct

This product allows you to interface with XML-RPC server

"""

__version__='$Revision: 0.01 $'[11:-2]

from Globals import Persistent, HTMLFile, MessageDialog, HTML
import OFS.SimpleItem
from string import split, join, find, lower
import AccessControl.Role, sys, os, traceback
import Acquisition
from Acquisition import Explicit
from OFS.SimpleItem import pretty_tb
from App.Extensions import getObject, getPath, FuncCode
from Globals import DevelopmentMode
from ExtensionClass import Base
import xmlrpclib

manage_addXMLRPCClientForm=HTMLFile('methodAdd', globals())

def manage_addXMLRPCClient(self, id, title, server, myMethods, REQUEST=None):
    """Add an xmlrpcclient
    """
    i=DemoClient(id,title,server, myMethods)
    self._setObject(id,i)
    return self.manage_main(self,REQUEST)

class XMLRPCClient(Base, Persistent, OFS.SimpleItem.Item, Explicit,
                  AccessControl.Role.RoleManager):

    meta_type='XMLRPC Client'
    server = ''
    myMethods=()

    manage_options=(
        {'label':'Properties', 'action':'manage_main'},
        {'label':'Security', 'action':'manage_access'},
        )

    __ac_permissions__=(
        ('View management screens', ('manage_main',)),
        ('Change XMLRPC Methods', ('manage_edit',)),
        ('View', ('__call__','')),
        )

    def __init__(self, id, title, server, myMethods):
        self.id=id
        self.manage_edit(title, server, myMethods)

    manage_main=HTMLFile('methodEdit', globals())

    def manage_edit(self, title, server, myMethods, REQUEST=None):
	"""Change the XML-RPC Method

	"""

        self.title=title
	self.server=server

	self.myMethods=split(myMethods)


    def __call__(self, function_name, *args):
	""" THis is a docstring

	"""

	myserv = xmlrpclib.Server(self.server)
	return apply((getattr(myserv,function_name)),args)

    def showMethods(self):
	retVal = ''
	for x in self.myMethods:
		retVal = retVal + x + " "
	return retVal

class MethodMaker(Base):

        def __init__(self, name):
                self.name=name

        def __of__(self,client):
		print "__of__ called with: " , client , " and name", self.name
                myserv = xmlrpclib.Server(client.server)
	        return getattr(myserv,self.name)


class DemoClient(XMLRPCClient):

    	def manage_edit(self, title, server, myMethods, REQUEST=None):
		"""Change the XML-RPC Method
	
		"""

		for x in self.myMethods:
			if hasattr(self, x):
				delattr(self, x)
		XMLRPCClient.manage_edit(self, title, server, myMethods)

		for x in self.myMethods:
			print "add method: ",  x
			setattr(self, x, MethodMaker(x))


	        if REQUEST: return MessageDialog(
        	    title  ='Changed %s' % self.id,
	            message='%s has been updated' % self.id,
        	    action =REQUEST['URL1']+'/manage_main',
	            target ='manage_main')







